#define NOTAG     0
#define NOCOMM    1
#define SINGLE    2
#define BROADCAST 3
#define SHIFT     4
#define CONCAT    5
#define ROTATE    7
#define IRREGULAR 8

struct {
     Node *Name;
     int dim;   /* the dimension of TEMPLATE which Name index is dist */
     int dist;
} index_dist[7];


/* dist 
   distribution typ of Name index
   it reruns 1 for BLOCK
             2 for CYCLIC
             0 none
*/

int psize;




extern Node *comm_ForallStmt();
extern tag_var ();
extern tag_communication_elements ();
extern Node *has_loop_index();
extern pattern_match();
extern shift();
extern dist();
extern idim();
extern Node *generate_communication ();
extern is_broadcast_need();
extern is_comm_need();
extern parti();
extern Node *make_if();
extern Node *forall_to_do();
extern Node *fill_coord_parti();
extern Node *fill_procs_parti();
extern Node *fill_local_parti();
extern increment();
extern decrement();
extern initialize();
extern ifschedule();
extern Node *gather();
extern Node *get_int_temp();
extern find_parti_size();
